[Python学习笔记-003] 使用PyOTP获取基于OTOP算法的动态口令

建立安全的VPN连接,不仅需要输入用户名和密码,还需要输入动态口令(token)。作为一个懒人,我更喜欢什么手工输入都不需要,既不需要输入password,也不需要输入token。也就是说,只需一个命令就能径直连接上VPN,那自然是极好滴。那么,懒人的愿望能实现吗?答案是肯定的!本文将基于FreeOTP 支持的TOTP(Time-based One-Time Password)算法,介绍如何利用Python代码自动获取动态口令(token),进而利用Expect实现一个自动连接VPN的Bash脚本。

PyOTP是一套开源的函数库,可用来计算基于TOTP算法的Token。有关TOTP算法的细节,本文不做介绍,如有兴趣请参考这里

1. 下载PyOTP

huanli@ThinkPadT460:tmp$ git clone https://github.com/pyotp/pyotp.git
Cloning into 'pyotp'...
remote: Counting objects: 601, done.
remote: Total 601 (delta 0), reused 0 (delta 0), pack-reused 601
Receiving objects: 100% (601/601), 165.02 KiB | 207.00 KiB/s, done.
Resolving deltas: 100% (297/297), done.
huanli@ThinkPadT460:tmp$ 
huanli@ThinkPadT460:tmp$ tree /tmp/pyotp/src
/tmp/pyotp/src
└── pyotp
    ├── compat.py
    ├── hotp.py
    ├── __init__.py
    ├── otp.py
    ├── totp.py
    └── utils.py

1 directory, 6 files
huanli@ThinkPadT460:tmp$ 

2. 使用PyOTP

huanli@ThinkPadT460:tmp$ export PYTHONPATH=/tmp/pyotp/src:$PYTHONPATH
huanli@ThinkPadT460:tmp$ python
...<snip>...
>>> import base64
>>> import pyotp
>>> s = 'Hello World'
>>> secret = base64.b32encode(s)
>>> totp = pyotp.TOTP(secret)
>>> token = totp.now()
>>> print token
338462
>>>

由此可见,通过pyotp.TOTP()获取token非常容易。我们将调用到的核心代码实现如下:

# https://github.com/pyotp/pyotp/blob/master/src/pyotp/otp.py
    ..
    10  class TOTP(OTP):
    11      """
    12      Handler for time-based OTP counters.
    13      """
    14      def __init__(self, *args, **kwargs):
    15          """
    16          :param interval: the time interval in seconds
    17              for OTP. This defaults to 30.
    18          :type interval: int
    19          """
    20          self.interval = kwargs.pop('interval', 30)
    21          super(TOTP, self).__init__(*args, **kwargs)
    ..
    37      def now(self):
    38          """
    39          Generate the current time OTP
    40  
    41          :returns: OTP value
    42          :rtype: str
    43          """
    44          return self.generate_otp(self.timecode(datetime.datetime.now()))
    ..

# https://github.com/pyotp/pyotp/blob/master/src/pyotp/otp.py
    ..
     8  class OTP(object):
     9      """
    10      Base class for OTP handlers.
    11      """
    12      def __init__(self, s, digits=6, digest=hashlib.sha1):
    13          """
    14          :param s: secret in base32 format
    15          :type s: str
    16          :param digits: number of integers in the OTP. Some apps expect this to be 6 digits, others support more.
    17          :type digits: int
    18          :param digest: digest function to use in the HMAC (expected to be sha1)
    19          :type digest: callable
    20          """
    21          self.digits = digits
    22          self.digest = digest
    23          self.secret = s
    24
    25      def generate_otp(self, input):
    26          """
    27          :param input: the HMAC counter value to use as the OTP input.
    28              Usually either the counter, or the computed integer based on the Unix timestamp
    29          :type input: int
    30          """
    31          if input < 0:
    32              raise ValueError('input must be positive integer')
    33          hasher = hmac.new(self.byte_secret(), self.int_to_bytestring(input), self.digest)
    34          hmac_hash = bytearray(hasher.digest())
    35          offset = hmac_hash[-1] & 0xf
    36          code = ((hmac_hash[offset] & 0x7f) << 24 |
    37                  (hmac_hash[offset + 1] & 0xff) << 16 |
    38                  (hmac_hash[offset + 2] & 0xff) << 8 |
    39                  (hmac_hash[offset + 3] & 0xff))
    40          str_code = str(code % 10 ** self.digits)
    41          while len(str_code) < self.digits:
    42              str_code = '0' + str_code
    43  
    44          return str_code
    ..

下面给出完整的Python脚本:

  • vpn_token.py
 1 #!/usr/bin/python
 2 import sys
 3 import datetime
 4 import time
 5 
 6 def main(argc, argv):
 7     if argc != 3:
 8         sys.stderr.write("Usage: %s <token secret> <pyotp path>\n" % argv[0])
 9         return 1
10 
11     token_secret = argv[1]
12     pyotp_path = argv[2]
13 
14     sys.path.append(pyotp_path)
15     import pyotp
16     totp = pyotp.TOTP(token_secret)
17 
18     #
19     # The token is expected to be valid in 5 seconds,
20     # else sleep 5s and retry
21     #
22     while True:
23         tw = datetime.datetime.now() + datetime.timedelta(seconds=5)
24         token = totp.now()
25         if totp.verify(token, tw):
26             print "%s" % token
27             return 0
28         time.sleep(5)
29 
30     return 1
31 
32 if __name__ == '__main__':
33     sys.exit(main(len(sys.argv), sys.argv))
  • 来自Terminal的Token: 707907

  • 来自手机的Token: 707907

由此可见,跟PyOTP计算出的Token码完全一致。于是,我们就可以利用Expect实现完全自动的VPN连接。例如: (注: 这里使用sexpect

  • autovpn.sh (完整的代码请戳这里
  1 #!/bin/bash
  2 
  3 function get_vpn_user
  4 {
  5         typeset user=${VPN_USER:-"$(id -un)"}
  6         echo "$user"
  7         return 0
  8 }
  9 
 10 function get_vpn_password
 11 {
 12         typeset password=${VPN_PASSWORD:-"$(eval $($VPN_PASSWORD_HOOK))"}
 13         echo "$password"
 14         return 0
 15 }
 16 
 17 function get_vpn_token
 18 {
 19         typeset f_py_cb=/tmp/.vpn_token.py
 20         cat > $f_py_cb << EOF
 21 #!/usr/bin/python
 22 import sys
 23 import datetime
 24 import time
 25 
 26 def main(argc, argv):
 27     if argc != 3:
 28         sys.stderr.write("Usage: %s <token secret> <pyotp path>\\n" % argv[0])
 29         return 1
 30 
 31     token_secret = argv[1]
 32     pyotp_path = argv[2]
 33 
 34     sys.path.append(pyotp_path)
 35     import pyotp
 36     totp = pyotp.TOTP(token_secret)
 37 
 38     #
 39     # The token is expected to be valid in 5 seconds,
 40     # else sleep 5s and retry
 41     #
 42     while True:
 43         tw = datetime.datetime.now() + datetime.timedelta(seconds=5)
 44         token = totp.now()
 45         if totp.verify(token, tw):
 46             print "%s" % token
 47             return 0
 48         time.sleep(5)
 49 
 50     return 1
 51 
 52 if __name__ == '__main__':
 53     argv = sys.argv
 54     argc = len(argv)
 55     sys.exit(main(argc, argv))
 56 EOF
 57 
 58         typeset pyotp_path=$VPN_PYOTP_PATH
 59         typeset token_secret=$VPN_TOKEN_SECRET
 60         if [[ -z $token_secret ]]; then
 61                 token_secret=$(eval $($VPN_TOKEN_SECRET_HOOK))
 62         fi
 63 
 64         python $f_py_cb $token_secret $pyotp_path
 65         typeset ret=$?
 66         rm -f $f_py_cb
 67         return $ret
 68 }
 69 
 70 function get_vpn_conf
 71 {
 72         typeset conf=$VPN_CONF
 73         echo "$conf"
 74         return 0
 75 }
 76 
 77 function check_sexpect
 78 {
 79         type sexpect 2>&1 | egrep 'not found' > /dev/null 2>&1
 80         (( $? != 0 )) && return 0
 81         return 1
 82 }
 83 
 84 vpn_user=$(get_vpn_user)
 85 (( $? != 0 )) && exit 1
 86 vpn_password=$(get_vpn_password)
 87 (( $? != 0 )) && exit 1
 88 vpn_token=$(get_vpn_token)
 89 (( $? != 0 )) && exit 1
 90 vpn_conf=$(get_vpn_conf)
 91 (( $? != 0 )) && exit 1
 92 
 93 check_sexpect || exit 1
 94 
 95 export SEXPECT_SOCKFILE=/tmp/sexpect-ssh-$$.sock
 96 trap '{ sexpect close && sexpect wait; } > /dev/null 2>&1' EXIT
 97 
 98 sexpect spawn sudo openvpn --config $vpn_conf
 99 sexpect set -timeout 60 # XXX: 'set' should be invoked after server is running
100 
101 while :; do
102         sexpect expect -nocase -re "Username:|Password:"
103         ret=$?
104         if (( $ret == 0 )); then
105                 out=$(sexpect expect_out)
106                 if [[ $out == *"Username:"* ]]; then
107                         sexpect send -enter "$vpn_user"
108                 elif [[ $out == *"Password:"* ]]; then
109                         sexpect send -enter "$vpn_password$vpn_token"
110                         break
111                 else
112                         echo "*** unknown catch: $out" >&2
113                         exit 1
114                 fi
115         elif sexpect chkerr -errno $ret -is eof; then
116                 sexpect wait
117                 exit 0
118         elif sexpect chkerr -errno $ret -is timeout; then
119                 sexpect close
120                 sexpect wait
121                 echo "*** timeout waiting for username/password prompt" >&2
122                 exit 1
123         else
124                 echo "*** unknown error: $ret" >&2
125                 exit 1
126         fi
127 done
128 
129 sexpect interact
  • 运行autovpn.sh
huanli@ThinkPadT460:~$ ./autovpn.sh 
Sat Aug 11 22:32:17 2018 OpenVPN 2.4.6 x86_64-redhat-linux-gnu [SSL (OpenSSL)] [LZO] [LZ4] [EPOLL] [PKCS11] [MH/PKTINFO] [AEAD] built on Apr 26 2018
Sat Aug 11 22:32:17 2018 library versions: OpenSSL 1.1.0h-fips  27 Mar 2018, LZO 2.08
Enter Auth Username: huanli
Enter Auth Password: ****************
Sat Aug 11 22:32:17 2018 NOTE: the current --script-security setting may allow this configuration to call user-defined scripts
...<snip>...
Sat Aug 11 22:32:20 2018 GID set to openvpn
Sat Aug 11 22:32:20 2018 UID set to openvpn
Sat Aug 11 22:32:20 2018 Initialization Sequence Completed

 

转载于:https://www.cnblogs.com/idorax/p/9461175.html

  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
在现有省、市港口信息化系统进行有效整合基础上,借鉴新 一代的感知-传输-应用技术体系,实现对码头、船舶、货物、重 大危险源、危险货物装卸过程、航管航运等管理要素的全面感知、 有效传输和按需定制服务,为行政管理人员和相关单位及人员提 供高效的管理辅助,并为公众提供便捷、实时的水运信息服务。 建立信息整合、交换和共享机制,建立健全信息化管理支撑 体系,以及相关标准规范和安全保障体系;按照“绿色循环低碳” 交通的要求,搭建高效、弹性、高可扩展性的基于虚拟技术的信 息基础设施,支撑信息平台低成本运行,实现电子政务建设和服务模式的转变。 实现以感知港口、感知船舶、感知货物为手段,以港航智能 分析、科学决策、高效服务为目的和核心理念,构建“智慧港口”的发展体系。 结合“智慧港口”相关业务工作特点及信息化现状的实际情况,本项目具体建设目标为: 一张图(即GIS 地理信息服务平台) 在建设岸线、港口、港区、码头、泊位等港口主要基础资源图层上,建设GIS 地理信息服务平台,在此基础上依次接入和叠加规划建设、经营、安全、航管等相关业务应用专题数据,并叠 加动态数据,如 AIS/GPS/移动平台数据,逐步建成航运管理处 "一张图"。系统支持扩展框架,方便未来更多应用资源的逐步整合。 现场执法监管系统 基于港口(航管)执法基地建设规划,依托统一的执法区域 管理和数字化监控平台,通过加强对辖区内的监控,结合移动平 台,形成完整的多维路径和信息追踪,真正做到问题能发现、事态能控制、突发问题能解决。 运行监测和辅助决策系统 对区域港口与航运业务日常所需填报及监测的数据经过科 学归纳及分析,采用统一平台,消除重复的填报数据,进行企业 输入和自动录入,并进行系统智能判断,避免填入错误的数据, 输入的数据经过智能组合,自动生成各业务部门所需的数据报 表,包括字段、格式,都可以根据需要进行定制,同时满足扩展 性需要,当有新的业务监测数据表需要产生时,系统将分析新的 需求,将所需字段融合进入日常监测和决策辅助平台的统一平台中,并生成新的所需业务数据监测及决策表。 综合指挥调度系统 建设以港航应急指挥中心为枢纽,以各级管理部门和经营港 口企业为节点,快速调度、信息共享的通信网络,满足应急处置中所需要的信息采集、指挥调度和过程监控等通信保障任务。 设计思路 根据项目的建设目标和“智慧港口”信息化平台的总体框架、 设计思路、建设内容及保障措施,围绕业务协同、信息共享,充 分考虑各航运(港政)管理处内部管理的需求,平台采用“全面 整合、重点补充、突出共享、逐步完善”策略,加强重点区域或 运输通道交通基础设施、运载装备、运行环境的监测监控,完善 运行协调、应急处置通信手段,促进跨区域、跨部门信息共享和业务协同。 以“统筹协调、综合监管”为目标,以提供综合、动态、实 时、准确、实用的安全畅通和应急数据共享为核心,围绕“保畅通、抓安全、促应急"等实际需求来建设智慧港口信息化平台。 系统充分整合和利用航运管理处现有相关信息资源,以地理 信息技术、网络视频技术、互联网技术、移动通信技术、云计算 技术为支撑,结合航运管理处专网与行业数据交换平台,构建航 运管理处与各部门之间智慧、畅通、安全、高效、绿色低碳的智 慧港口信息化平台。 系统充分考虑航运管理处安全法规及安全职责今后的变化 与发展趋势,应用目前主流的、成熟的应用技术,内联外引,优势互补,使系统建设具备良好的开放性、扩展性、可维护性。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值